// HFCLKAhXEf[^doXC^[tFCXiAhXfR[_j
// 쐬ҎFai݌vRT^gj
// t@CFadr_dec.v   
module ADR_DEC (ADR,BASE_ADR,BASE_HIT
               ,ADR0_DEC,ADR0_HIT,ADR0_RDATA
               ,ADR1_DEC,ADR1_HIT,ADR1_RDATA
               ,ADR2_DEC,ADR2_HIT,ADR2_RDATA
               ,ADR3_DEC,ADR3_HIT,ADR3_RDATA
               ,DATA_OUT,NO_HIT);
parameter  ADR_WIDTH=8;
parameter  BASE_WIDTH=6;
parameter  DATA_WIDTH=8;
input [ADR_WIDTH-1:0]   ADR;
input [BASE_WIDTH-1: 0] BASE_ADR;      
output                  BASE_HIT;
input [ADR_WIDTH-BASE_WIDTH-1:0] ADR0_DEC,ADR1_DEC,ADR2_DEC,ADR3_DEC;
output                  ADR0_HIT,ADR1_HIT,ADR2_HIT,ADR3_HIT;
input  [DATA_WIDTH-1:0] ADR0_RDATA,ADR1_RDATA,ADR2_RDATA,ADR3_RDATA;
output [DATA_WIDTH-1:0] DATA_OUT;
output                  NO_HIT;
reg [DATA_WIDTH-1:0] DATA_OUT;
reg [DATA_WIDTH-1:0] DATA_TMP;
wire [ADR_WIDTH-BASE_WIDTH-1:0]LOCAL_ADR;
integer i;
// decode
assign   LOCAL_ADR = ADR[ADR_WIDTH-BASE_WIDTH-1 : 0];   
assign   BASE_HIT  = (ADR[ADR_WIDTH-1 : ADR_WIDTH-BASE_WIDTH] == BASE_ADR) ;
assign   ADR0_HIT  = ((BASE_HIT==1'b1) && (LOCAL_ADR == ADR0_DEC));
assign   ADR1_HIT  = ((BASE_HIT==1'b1) && (LOCAL_ADR == ADR1_DEC));
assign   ADR2_HIT  = ((BASE_HIT==1'b1) && (LOCAL_ADR == ADR2_DEC));
assign   ADR3_HIT  = ((BASE_HIT==1'b1) && (LOCAL_ADR == ADR3_DEC));
assign   NO_HIT    = ((ADR0_HIT==1'b0) && (ADR1_HIT==1'b0) && (ADR2_HIT==1'b0) && (ADR3_HIT==1'b0));
// select data    
always@(LOCAL_ADR  or BASE_HIT
        or  ADR0_HIT or ADR0_RDATA
        or  ADR1_HIT or ADR1_RDATA
        or  ADR2_HIT or ADR2_RDATA
        or  ADR3_HIT or ADR3_RDATA)
   begin
      for(i=0;i<=DATA_WIDTH-1;i=i+1)  
         DATA_TMP[i] =1'b0;
      if (BASE_HIT==1'b1) 
         begin 
            if (ADR0_HIT ==1'b1) 
               DATA_TMP =ADR0_RDATA;
            if (ADR1_HIT ==1'b1) 
               DATA_TMP =ADR1_RDATA;
            if (ADR2_HIT ==1'b1) 
               DATA_TMP =ADR2_RDATA;
            if (ADR3_HIT ==1'b1) 
               DATA_TMP =ADR3_RDATA;
         end
      DATA_OUT <= DATA_TMP;
   end  
endmodule

