// HF
// t@CFbcdcnt.v

module timer (CLK, RESET_N
             ,EN,START,STOP,LAP
             ,COUNT_10M,COUNT_100M,COUNT_1S
             ,COUNT_A,COUNT_B,COUNT_C);

input CLK,RESET_N ;
input       EN;
input       START;
input       STOP;
input       LAP;

output [3:0] COUNT_10M;
output [3:0] COUNT_100M;
output [3:0] COUNT_1S;   
output [3:0] COUNT_A ;
output [3:0] COUNT_B ;
output [3:0] COUNT_C ;

wire      RESET ;
      
reg [3:0] COUNT_A ;
reg [3:0] COUNT_B ;
reg [3:0] COUNT_C ;

wire   INC = 1'b1;
wire [3:0] DATA = 4'h0;
   
//wire EN_1M;
wire EN_100N;
wire START_BASE_CNT;
   
wire CARRY_20N;
wire CARRY_100N;
wire CARRY_1U;
wire CARRY_10U;
wire CARRY_100U;
wire CARRY_1M;
wire CARRY_10M;
wire CARRY_100M;
wire CARRY_1S;
   
wire [3:0] COUNT_20N;
wire [3:0] COUNT_100N;
wire [3:0] COUNT_1U;
wire [3:0] COUNT_10U;
wire [3:0] COUNT_100U;
wire [3:0] COUNT_1M;
wire [3:0] COUNT_10M;
wire [3:0] COUNT_100M;
wire [3:0] COUNT_1S;   
 
//
//Zbg̋ɐ
//
assign  RESET = ~ RESET_N;

//
// o͂̏
//    

always @(posedge CLK or posedge RESET)
begin
if (RESET == 1'b1)
  begin
     COUNT_A <= 4'h0;
     COUNT_B <= 4'h0;
     COUNT_C <= 4'h0;     
  end
else
  if ((STOP==1'b1)||(LAP==1'b1)) //stop or lap
    begin
       /*
       COUNT_A <= COUNT_10M;
       COUNT_B <= COUNT_100M;
       COUNT_C <= COUNT_1S;
       */
       COUNT_A <= COUNT_1U;
       COUNT_B <= COUNT_10U;
       COUNT_C <= COUNT_100U;     
    end
  else
    begin
       COUNT_A <= COUNT_A;
       COUNT_B <= COUNT_B;
       COUNT_C <= COUNT_C;     
    end
end

//
//JE^   
//

BCDCNT U_20N(.CLK(CLK)
            ,.RESET(RESET)
            ,.LOAD(START_BASE_CNT)
            ,.INC(INC)
            ,.EN(EN)
            ,.DATA(DATA)
            ,.COUNT(COUNT_20N)
            ,.CARRY(CARRY_20N));
     
   
assign EN_100N=((EN==1'b1)&&(COUNT_20N==4'h4))?1'b1:1'b0;
assign START_BASE_CNT = ((START==1'b1)||(EN_100N==1'b1))?1'b1:1'b0;
   
BCDCNT U_100N(.CLK(CLK)
            ,.RESET(RESET)
            ,.LOAD(START)
            ,.INC(INC)
            ,.EN(EN_100N)
            ,.DATA(DATA)
            ,.COUNT(COUNT_100N)
            ,.CARRY(CARRY_100N));
   

BCDCNT U_1U( .CLK(CLK)
            ,.RESET(RESET)
            ,.LOAD(START)
            ,.INC(INC)
            ,.EN(CARRY_100N)
            ,.DATA(DATA)
            ,.COUNT(COUNT_1U)
            ,.CARRY(CARRY_1U));
             
BCDCNT U_10U( .CLK(CLK)
            ,.RESET(RESET)
            ,.LOAD(START)
            ,.INC(INC)
            ,.EN(CARRY_1U)
            ,.DATA(DATA)
            ,.COUNT(COUNT_10U)
            ,.CARRY(CARRY_10U));

BCDCNT U_100U( .CLK(CLK)
            ,.RESET(RESET)
            ,.LOAD(START)
            ,.INC(INC)
            ,.EN(CARRY_10U)
            ,.DATA(DATA)
            ,.COUNT(COUNT_100U)
            ,.CARRY(CARRY_100U));

//assign EN_1M=((EN==1'b1)&&(COUNT_30N==4'h9)&&(COUNT_300N==4'h9)&&
//              (COUNT_3U==4'h9)&&(COUNT_30U==4'h2)&&(COUNT_300U==4'h3))?1'b1:1'b0;
//        
//assign START_BASE_CNT = ((START==1'b1)||(EN_1M==1'b1))?1'b1:1'b0;
       
BCDCNT U_1M( .CLK(CLK)
            ,.RESET(RESET)
            ,.LOAD(START)
            ,.INC(INC)
            ,.EN(CARRY_100U)
            ,.DATA(DATA)
            ,.COUNT(COUNT_1M)
            ,.CARRY(CARRY_1M));

             
BCDCNT U_10M( .CLK(CLK)
            ,.RESET(RESET)
            ,.LOAD(START)
            ,.INC(INC)
            ,.EN(CARRY_1M)
            ,.DATA(DATA)
            ,.COUNT(COUNT_10M)
            ,.CARRY(CARRY_10M));

BCDCNT U_100M( .CLK(CLK)
            ,.RESET(RESET)
            ,.LOAD(START)
            ,.INC(INC)
            ,.EN(CARRY_10M)
            ,.DATA(DATA)
            ,.COUNT(COUNT_100M)
            ,.CARRY(CARRY_100M));
               
BCDCNT U_1S( .CLK(CLK)
            ,.RESET(RESET)
            ,.LOAD(START)
            ,.INC(INC)
            ,.EN(CARRY_100M)
            ,.DATA(DATA)
            ,.COUNT(COUNT_1S)
            ,.CARRY(CARRY_1S));

   
endmodule

