//Legal Notice: (C)2008 Altera Corporation. All rights reserved.  Your
//use of Altera Corporation's design tools, logic functions and other
//software and tools, and its AMPP partner logic functions, and any
//output files any of the foregoing (including device programming or
//simulation files), and any associated documentation or information are
//expressly subject to the terms and conditions of the Altera Program
//License Subscription Agreement or other applicable license agreement,
//including, without limitation, that your use is for the sole purpose
//of programming logic devices manufactured by Altera and sold by Altera
//or its authorized distributors.  Please refer to the applicable
//agreement for further details.

// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on

// turn off superfluous verilog processor warnings 
// altera message_level Level1 
// altera message_off 10034 10035 10036 10037 10230 10240 10030 

module user_blk_a (
               // inputs:
                address,
                chipselect,
                clk,
                reset_n,
                write_n,
                writedata,
                in_port,
               // outputs:
                readdata,
                //led
                led_1,
                led_2,
                led_3,
                int_user
             )
;
  //bus if
  output  [  7: 0] readdata;
  input   [  7: 0] address;
  input            chipselect;
  input            clk;
  input            reset_n;
  input            write_n;
  input   [  7: 0] writedata;
  //sw input 
  input   [  3: 0] in_port;
  //led
  //output  [   3:0] led;
  output  [  6: 0] led_1;
  output  [  6: 0] led_2;
  output  [  6: 0] led_3;
  output           int_user;
   
   
  wire    [7:0]    io0_data_i;
  wire    [7:0]    io1_data_i;
  wire    [7:0]    io2_data_i;
  wire    [7:0]    io3_data_i;
  wire    [3:0]    io0_data_o;

  wire [3:0]       count_10m;
  wire [3:0]       count_100m;
  wire [3:0]       count_1s;
  wire [3:0]       count_a;
  wire [3:0]       count_b;
  wire [3:0]       count_c;

  wire START;
  wire EN;
  wire STOP;
  wire LAP;
   
  wire [7:0]       count_1u;
  wire [7:0]       count_10u;
  wire [7:0]       count_100u;
   
  wire [6:0]       led_1_n;
  wire [6:0]       led_2_n;
  wire [6:0]       led_3_n;
   
 
  assign           io0_data_i = {5'h0,LAP,STOP,START};
  assign           io1_data_i = {4'h0,count_a};
  assign           io2_data_i = {4'h0,count_b};
  assign           io3_data_i = {4'h0,count_c};

  //assign led = count_1s;
  /* 
  assign           led_1 = ~ led_1_n;
  assign           led_2 = ~ led_2_n;
  assign           led_3 = ~ led_3_n;
  */    
   
  busif_wrapper  busif_wrapper_0 (
        .clk(clk) 
       ,.reset_n(reset_n) 
       ,.chipselect (chipselect) 
       ,.write_n(write_n) 
       ,.address(address) 
       ,.writedata(writedata) 
       ,.io0_data_i(io0_data_i)    
       ,.io1_data_i(io1_data_i)    
       ,.io2_data_i(io2_data_i)    
       ,.io3_data_i(io3_data_i)     
       ,.readdata(readdata)   
       ,.io0_data_o(io0_data_o)
       ,.cnt_1(count_1u)
       ,.cnt_2(count_10u)
       ,.cnt_3(count_100u)
       ,.led_1(led_1)
       ,.led_2(led_2)
       ,.led_3(led_3)
       ,.int_user(int_user)    
      );

  timer timer_0 (
        .CLK(clk)
       ,.RESET_N(reset_n)
       ,.EN(EN)
       ,.START(START)
       ,.STOP(STOP)
       ,.LAP(LAP)
       ,.COUNT_1U(count_1u)
       ,.COUNT_10U(count_10u)
       ,.COUNT_100U(count_100u)
       ,.COUNT_10M(count_10m)
       ,.COUNT_100M(count_100m)
       ,.COUNT_1S(count_1s)
       ,.COUNT_A(count_a)
       ,.COUNT_B(count_b)
       ,.COUNT_C(count_c)
                 );
   
  SW_IF SW_IF_0 (
        .CLK(clk)
       ,.RSTN(reset_n)
       ,.IN_PORT(in_port[2:0])
       ,.EN(EN)
       ,.START(START)
       ,.STOP(STOP)
       ,.LAP(LAP)
         );              
 /*  
  BCD7 bcd7_1(
       .bcd(count_10m)
      ,.led(led_1_n)
       );  
 
  BCD7 bcd7_2(
       .bcd(count_100m)
      ,.led(led_2_n)
       );  
 
  BCD7 bcd7_3(
       .bcd(count_1s)
      ,.led(led_3_n)
       );
 */ 
endmodule

